-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["MONK"] = {}
local t,s,n
lib.classes["MONK"][1] = function()
	lib.AddSpell("Palm",{100787},true) --Tiger Palm
	lib.AddAura("Power",125359,"buff","player") -- Tiger Power
	lib.AddSpell("Kick",{100784},true) --Blackout Kick
--	lib.AddSpell("Blossoms",{124336}) --Path of Blossoms
	lib.AddSpell("Keg",{121253},nil,true) --Keg Smash
	lib.AddSpell("Haze",{115180}) --Dizzying Haze
--	lib.AddAura("Haze",116330,"debuff","target") -- Dizzying Haze (123727 - Keg, 116330 - Dizzying Haze)
	lib.AddAuras("Haze",{123727,116330},"debuff","target") -- Dizzying Haze (123727 - Keg, 116330 - Dizzying Haze)
	lib.AddAura("Weakened",115798,"debuff","target","any") -- Weakened Blows
	lib.AddSpell("Breath",{115181},true) -- Breath of Fire
	lib.AddAura("Breath",123725,"debuff","target") -- Breath of Fire
	lib.AddSpell("Sphere",{124081}) -- Zen Sphere
	lib.AddAura("Sphere",124081,"buff","player") -- Zen Sphere
	lib.AddSpell("Guard",{115295},true) -- Guard
	lib.AddAura("Guard",115295,"buff","player") -- Guard
	lib.AddSpell("Brewmaster_Training",{117967})
	lib.AddAura("Power_Guard",118636,"buff","player") -- Power_Guard
	lib.AddSpell("Death",{115080}) -- Touch of Death
	lib.AddAura("Shuffle",115307,"buff","player") -- Shuffle
	lib.AddSpell("Brew",{115308},true) -- Elusive Brew
	lib.AddAura("Brew",128939,"buff","player") -- Elusive Brew stacks
	lib.AddAura("Brew_buff",115308,"buff","player") -- Elusive Brew buff
	lib.AddSpell("Purifying",{119582},true) -- Purifying Brew
	--lib.AddAura("Stagger2",124274,"debuff","player") -- Moderate Stagger
	--lib.AddAura("Stagger3",124273,"debuff","player") -- Heavy Stagger
	lib.AddAuras("Stagger",{124274,124273}, "debuff","player")
	lib.AddSpell("Chi_Wave",{115098}) -- Chi-Wave
	
	cfg.TrackDOT="Breath"
	
	
	cfg.plistdps = {}
--	table.insert(cfg.plistdps,"Death")
	table.insert(cfg.plistdps,"Purifying_Stagger")
	table.insert(cfg.plistdps,"Kick_Shuffle")
	table.insert(cfg.plistdps,"Palm_Power")
	table.insert(cfg.plistdps,"Guard_Guard")
	table.insert(cfg.plistdps,"Brew_Brew")
	--table.insert(cfg.plistdps,"Sphere_noSphere")
	--table.insert(cfg.plistdps,"Breath_Breath")
	table.insert(cfg.plistdps,"Kick_3chi")
	table.insert(cfg.plistdps,"Chi_Wave")
	table.insert(cfg.plistdps,"Keg")
	table.insert(cfg.plistdps,"Expel")
	table.insert(cfg.plistdps,"Jab")
	table.insert(cfg.plistdps,"Palm_Brewmaster")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
--	table.insert(cfg.plistaoe,"Expel")
--	table.insert(cfg.plistaoe,"Haze_15sec")
--	table.insert(cfg.plistaoe,"Guard")
	table.insert(cfg.plistaoe,"Purifying_Stagger")
	table.insert(cfg.plistaoe,"Palm_Power")
	table.insert(cfg.plistaoe,"Sphere_noSphere")
	table.insert(cfg.plistaoe,"Breath_Breath")
	table.insert(cfg.plistaoe,"Kick_Shuffle")
	table.insert(cfg.plistaoe,"Guard_Guard")
	table.insert(cfg.plistaoe,"Brew_Brew")
--	table.insert(cfg.plistaoe,"Sphere")
	table.insert(cfg.plistaoe,"Keg")
--	table.insert(cfg.plistaoe,"Breath")
--	table.insert(cfg.plistaoe,"Jab_15sec")
	table.insert(cfg.plistaoe,"Spin")
	table.insert(cfg.plistaoe,"Chi_Wave")
	table.insert(cfg.plistaoe,"Expel")
	table.insert(cfg.plistaoe,"Jab_aoe")
	table.insert(cfg.plistaoe,"Palm_Brewmaster")
	table.insert(cfg.plistaoe,"end")
	
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Guard_Guard"] = function()
			return lib.SimpleCDCheck("Guard",lib.GetAura({"Guard"})-9)
		end,
		["Palm_Brewmaster"] = function()
			if (lib.KnownSpell("Brewmaster_Training")) then
				return lib.SimpleCDCheck("Palm")
			end
			return nil
		end,
		["Kick_Shuffle"] = function()
			return lib.SimpleCDCheck("Kick",lib.GetAura({"Shuffle"})-1.8)
		end,
		["Kick_3chi"] = function()
			if cfg.chi>=4 then
				return lib.SimpleCDCheck("Kick")
			end
			return nil
		end,
		["Haze_15sec"] = function()
			return lib.SimpleCDCheck("Haze",13-lib.GetLastCast(lib.GetSpellName("Haze")))
		end,
		["Brew_Brew"] = function()
			--if cfg.target=="normal" then return nil end
			if lib.GetAuraNum("Brew")>=9 then
				return lib.SimpleCDCheck("Brew",lib.GetAura({"Brew_buff"}))
			end
			return nil
		end,
		["Breath_Breath"] = function()
			return lib.SimpleCDCheck("Breath",lib.GetAura({"Breath"})-2.4)
		end,
		["Palm"] = function()
			if cfg.chi<2 then return nil end
			if lib.GetAura({"Power"})==0 or lib.GetAuraNum("Power")<3 then
				return lib.SimpleCDCheck("Palm")
			end
			return nil
		end,
		["Palm_Power"] = function()
			return lib.SimpleCDCheck("Palm",lib.GetAura({"Power"})-6)
		end,
		["Purifying_Stagger"] = function()
			if lib.GetAuras("Stagger")>0 then return lib.SimpleCDCheck("Purifying") end
			return nil
		end,
		["Keg"] = function()
			return lib.SimpleCDCheck("Keg")
		end,
		["Jab_15sec"] = function()
			if cfg.chi>=cfg.chimax-2 then return nil end
			if lib.TimeEnergy(lib.GetSpellCD("Keg"))>=(lib.GetSpellCost("Keg")+lib.GetSpellCost("Jab")) then
				return lib.SimpleCDCheck("Jab",15-lib.GetLastCast(lib.GetSpellName("Jab")))
			end
			return nil
		end,
		["Jab_aoe"] = function()
			if cfg.chimax-cfg.chi>=2 then
				return lib.SimpleCDCheck("Jab",lib.Time2Energy(80))
			end
			return nil
		end,
	}
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end

	return true
end
lib.classes["MONK"][3] = function()
	
	lib.AddSpell("RSK",{107428},true) --Rising Sun Kick
	lib.AddAura("RSK",130320,"debuff","target") -- Rising Sun Kick
	lib.AddAura("CBTP",118864,"buff","player") -- Combo Breaker: Tiger Palm
	lib.AddAura("CBBK",116768,"buff","player") -- Combo Breaker: Blackout Kick
	
	lib.AddSpell("Palm",{100787},true) --Tiger Palm
	lib.AddAura("Power",125359,"buff","player") -- Tiger Power
	lib.AddSpell("Kick",{100784},true) --Blackout Kick
	lib.AddSpell("TB",{116740}) -- Tigereye Brew
	lib.AddAura("TB",125195,"buff","player") -- Tigereye Brew
	lib.AddAura("TBB",116740,"buff","player") -- Tigereye Brew
	lib.AddSpell("Sphere",{124081}) -- Zen Sphere
	lib.AddAura("Sphere",124081,"buff","player") -- Zen Sphere
	lib.AddSpell("Death",{115080},true) -- Touch of Death
	lib.AddAura("Death",121125,"buff","player") -- Death Note
	lib.AddSpell("Xuen",{123904}) --Invoke Xuen, the White Tiger
	
	lib.AddSpell("Fortifying",{115203}) -- Fortifying Brew
	lib.AddSpell("Chi_Wave",{115098}) -- Chi-Wave
	lib.AddSpell("Fists",{113656},true) -- Fists of Fury
	lib.AddSpell("EB",{115288}) -- Energizing Brew
	lib.AddSpell("Chi_Brew",{115399}) -- Chi Brew
	lib.AddSpell("Serenity",{152173}) -- Serenity
	lib.AddAura("Serenity",152173,"buff","player") -- Serenity
	
	
		
	cfg.plistdps = {}
--	table.insert(cfg.plistdps,"Expel")
--	table.insert(cfg.plistdps,"Jab")
	table.insert(cfg.plistdps,"Xuen")
	table.insert(cfg.plistdps,"Chi_Brew")
	--table.insert(cfg.plistdps,"Fortifying")
	table.insert(cfg.plistdps,"Death")
	table.insert(cfg.plistdps,"TB_10TB")
	table.insert(cfg.plistdps,"Palm_Power")
	table.insert(cfg.plistdps,"RSK_RSK")
	table.insert(cfg.plistdps,"Serenity")
	table.insert(cfg.plistdps,"Fists_single")
	table.insert(cfg.plistdps,"RSK")
	table.insert(cfg.plistdps,"CB")
	table.insert(cfg.plistdps,"Chi_Wave")
	table.insert(cfg.plistdps,"Expel")
	table.insert(cfg.plistdps,"Jab")
	table.insert(cfg.plistdps,"Kick_3chi")
	table.insert(cfg.plistdps,"EB")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
--	table.insert(cfg.plistaoe,"Expel")
--	table.insert(cfg.plistaoe,"Haze_15sec")
--	table.insert(cfg.plistaoe,"Guard")
	table.insert(cfg.plistaoe,"RSK_RSK_aoe")
	table.insert(cfg.plistaoe,"Palm_Power_aoe")
	table.insert(cfg.plistaoe,"RSK_aoe")
	table.insert(cfg.plistaoe,"Fists_aoe")
--	table.insert(cfg.plistaoe,"Sphere_noSphere")
--	table.insert(cfg.plistaoe,"Breath_Haze")
--	table.insert(cfg.plistaoe,"Sphere")
--	table.insert(cfg.plistaoe,"Keg")
--	table.insert(cfg.plistaoe,"Breath")
--	table.insert(cfg.plistaoe,"Jab_15sec")
	table.insert(cfg.plistaoe,"Spin")
	table.insert(cfg.plistaoe,"Jab")
	table.insert(cfg.plistaoe,"CB_aoe")
	table.insert(cfg.plistaoe,"EB_aoe")
	table.insert(cfg.plistaoe,"end")
	
	
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Chi_Brew"] = function()
			if (cfg.chimax-cfg.chi)>=2 and lib.GetAuraNum("TB")<=16 and cfg.power<cfg.powermax then
				return lib.SimpleCDCheck("Chi_Brew")
			end
			return nil
		end,
		["CB"] = function()
			if lib.GetAura({"CBTP"})>0 then
				return lib.SimpleCDCheck("Palm")
			end
			if lib.GetAura({"CBBK"})>0 then
				return lib.SimpleCDCheck("Kick")
			end
			
			return nil
		end,
		
		["Death"] = function()
			if not lib.hardtarget() then return nil end
			if lib.GetAura({"Death"})>0 then
				return lib.SimpleCDCheck("Death")
			end
			return nil
		end,
		
		["EB"] = function()
			if cfg.realpower<40 and lib.GetSpellCD("Fists")>lib.GetSpellCD("EB")+6 then
				return lib.SimpleCDCheck("EB")
			end
			return nil
		end,
		
		["Fortifying"] = function()
			if not lib.hardtarget() then return nil end
			if lib.GetAura({"Death"})>0 then
				return lib.SimpleCDCheck("Fortifying")
			end
			return nil
		end,
		
		["Kick_3chi"] = function()
			if cfg.chimax-cfg.chi<=2 then
				return lib.SimpleCDCheck("Kick")
			end
			return nil
		end,

		["TB_10TB"] = function()
			if lib.hardtarget() and lib.GetAuraNum("TB")>=10 then
				return lib.SimpleCDCheck("TB",lib.GetAura({"TBB"}))
			end
				
			if not lib.hardtarget() and lib.GetAuraNum("TB")==20 then
				return lib.SimpleCDCheck("TB",lib.GetAura({"TBB"}))
			end
			return nil
		end,

		["Palm"] = function()
			if cfg.chi<2 then return nil end
			if lib.GetAura({"Power"})==0 or lib.GetAuraNum("Power")<3 then
				return lib.SimpleCDCheck("Palm")
			end
			return nil
		end,

		["Palm_Power"] = function()
			return lib.SimpleCDCheck("Palm",lib.GetAura({"Power"})-6)
		end,
		
		["RSK_RSK"] = function()
			return lib.SimpleCDCheck("RSK",lib.GetAura({"RSK"})-4.5)
		end,
		
		["Serenity"] = function()
			if lib.GetAura({"RSK"})>0 and lib.GetAura({"Power"})>0 and cfg.chi>=4 then
				return lib.SimpleCDCheck("Serenity")
			end
			return nil
		end,
		["Fists_single"] = function()
			if lib.GetAura({"Power"})+3>lib.GetSpellCD("Fists") and  lib.GetAura({"RSK"})+3>lib.GetSpellCD("Fists") and lib.GetAura({"Serenity"})==0 then
				return lib.SimpleCDCheck("Fists")
			end
			return nil
		end,
		["RSK_RSK_aoe"] = function()
			if cfg.chi<2 then return nil end
			return lib.SimpleCDCheck("RSK",lib.GetAura({"RSK"})-4.5,true)
		end,
		["RSK_aoe"] = function()
			if cfg.chi<2 then return nil end
			return lib.SimpleCDCheck("RSK",nil,true)
		end,
		["Palm_Power_aoe"] = function()
			if lib.GetAura({"CBTP"})>0 or cfg.chi>=1 then
				return lib.SimpleCDCheck("Palm",lib.GetAura({"Power"})-2,true)
			end
			return nil
		end,
		["Fists_aoe"] = function()
			if cfg.chi<3 then return nil end
			return lib.SimpleCDCheck("Fists",nil,true)
		end,
		["CB_aoe"] = function()
			if lib.GetAura({"CBTP"})>0 then
				return lib.SimpleCDCheck("Palm",nil,true)
			end
			if lib.GetAura({"CBBK"})>0 then
				return lib.SimpleCDCheck("Kick",nil,true)
			end
			
			return nil
		end,
		["EB_aoe"] = function()
			if cfg.realpower<40 then
				return lib.SimpleCDCheck("EB",nil,true)
			end
			return nil
		end,
		
	}
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end
	
	cfg.spells_aoe={"Spin1","Spin2"}
	--cfg.spells_single={"Kick"}
	return true
end


lib.classevents["MONK"] = function()
	lib.ChiPowerUpdate()
	function Heddclassevents.UNIT_POWER_FREQUENT(unit,powerType)
		if unit=="player" and powerType=="CHI" then
			lib.ChiPowerUpdate()
		end
	end

	lib.UpdatePlayerHealth()
	function Heddclassevents.UNIT_HEALTH_FREQUENT(unit)
		if unit=="player" then
			lib.UpdatePlayerHealth()
		end
	end
	
	if cfg.talenttree==1 or cfg.talenttree==3 then
		cfg.powertype="ENERGY"
		lib.AddAura("Power_Strikes",53817,"buff","player")
		lib.AddSpell("Jab",{100780,115693,115695,115687,115698,108557},nil,true)
		if cfg.spells["Jab"] then
			cfg.spells["Jab"].icon="Interface\\ICONS\\ability_monk_jab.blp"
			lib.SetSpellIcon("Jab")
		end
		cfg.case["Jab"] = function()
			if cfg.chimax-cfg.chi>=2 then
				return lib.SimpleCDCheck("Jab")
			end
			return nil
		end
	
		lib.AddSpell("Expel",{115072},nil,true) -- Expel Harm
		cfg.case["Expel"] = function()
			--if cfg.chi==cfg.chimax then return nil end
			if cfg.chimax-cfg.chi>=2 and cfg.phealthperc<=95 then
				return lib.SimpleCDCheck("Expel")
			end
			return nil
		end
		
		
		lib.AddSpell("Spin2",{116847},nil,true) -- Rushing Jade Wind
		lib.AddAura("Spin2",116847,"buff","player") -- Rushing Jade Wind
		lib.AddSpell("Spin1",{101546},nil,true) -- Spinning Crane Kick
		lib.AddAura("Spin1",101546,"buff","player") -- Spinning Crane Kick
		
		cfg.case["Spin"] = function()
			if lib.KnownSpell("Spin2") then
				return lib.SimpleCDCheck("Spin2")
			else 
				return lib.SimpleCDCheck("Spin1")
			end
			return nil
		end
		
		cfg.spells_aoe={"Spin1","Spin2"}
		lib.rangecheck=function()
			if lib.inrange("Jab") then
				lib.bdcolor(Heddframe.bd,nil)
			else
				lib.bdcolor(Heddframe.bd,{1,0,0,1})
			end
		end
		
		
		--[[function Heddclassevents.PLAYER_EQUIPMENT_CHANGED(slot, hasItem)
		end]]
	
		--Heddclassevents.PLAYER_EQUIPMENT_CHANGED()
	end
	lib.CD = function()
		lib.CDadd("Xuen")
		lib.CDadd("Chi_Brew")
		lib.CDadd("Serenity")
		lib.CDadd("Fists")
		lib.CDadd("Chi_Wave")
		lib.CDadd("EB")
	end
	lib.CD()
end